﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
Sub Process_Globals
	'Private states As Map
	Private listPosition As Int
	Private settingsFileName As String     'statesFileName, 
	'statesFileName = "state.dat"
	settingsFileName = "settings.properties"
	Private settings As Map
End Sub

Sub GetSetting2(Key As String, DefaultValue As String)
	If settings.IsInitialized = False Then
		'load the stored settings
		If File.Exists(File.DirInternal, settingsFileName) Then 
			settings = File.ReadMap(File.DirInternal, settingsFileName)
		Else
			Return DefaultValue					'ignore
		End If
	End If
	Private v As String
	v = settings.GetDefault(Key.ToLowerCase, DefaultValue)
	Return v										'ignore
End Sub

Sub SetSetting(Key As String, Value As String)
	If settings.IsInitialized = False Then
		'load the stored settings
		If File.Exists(File.DirInternal, settingsFileName) Then 
			settings = File.ReadMap(File.DirInternal, settingsFileName)
		Else
			settings.Initialize
		End If
	End If
	settings.Put(Key.ToLowerCase, Value)
End Sub

Sub SaveSettings
	If settings.IsInitialized Then
		File.WriteMap(File.DirInternal, settingsFileName, settings)
	End If
End Sub

Sub innerSaveState(v As View, list1 As List)
	Private data() As Object
	If v Is EditText Then
		Private edit As EditText
		edit = v
		data = Array As Object(edit.Text, edit.SelectionStart)
	Else If v Is Spinner Then
		Private spinner1 As Spinner
		spinner1 = v
		data = Array As Object(spinner1.SelectedIndex)
	Else If v Is CheckBox Then
		Private check As CheckBox
		check = v
		data = Array As Object(check.Checked)
	Else If v Is RadioButton Then
		Private radio As RadioButton
		radio = v
		data = Array As Object(radio.Checked)	
	Else If v Is ToggleButton Then
		Private toggle As ToggleButton
		toggle = v
		data = Array As Object(toggle.Checked)
	Else If v Is SeekBar Then
		Private seek As SeekBar
		seek = v
		data = Array As Object(seek.Value)
	Else If v Is TabHost Then
		Private th As TabHost
		th = v
		data = Array As Object(th.CurrentTab)
		For i = 0 To th.TabCount - 1
			th.CurrentTab = i
		Next
		list1.Add(data)
		Private data() As Object
		Private r As Reflector
		r.Target = th
		Private tabParentPanel As Panel
		tabParentPanel = r.RunMethod("getTabContentView")
		For i = 0 To tabParentPanel.NumberOfViews - 1
			innerSaveState(tabParentPanel.GetView(i), list1)
		Next
	Else If v Is ScrollView Then
		Private sv As ScrollView
		sv = v
		data = Array As Object(sv.ScrollPosition)
		list1.Add(data)
		Private data() As Object
		innerSaveState(sv.Panel, list1)
	Else If v Is Panel Then
		Private panel1 As Panel
		panel1 = v
		For i = 0 To panel1.NumberOfViews - 1
			innerSaveState(panel1.GetView(i), list1)
		Next
	End If
	If data.Length > 0 Then list1.Add(data)
End Sub

Sub innerRestoreState(v As View, list1 As List)
	Private data() As Object
	If v Is EditText Then
		Private edit As EditText
		edit = v
		data = getNextItem(list1)
		edit.Text = data(0)
		edit.SelectionStart = data(1)
	Else If v Is Spinner Then
		Private spinner1 As Spinner
		spinner1 = v
		data = getNextItem(list1)
		spinner1.SelectedIndex = data(0)
	Else If v Is CheckBox Then
		Private check As CheckBox
		check = v
		data = getNextItem(list1)
		check.Checked = data(0)
	Else If v Is RadioButton Then
		Private radio As RadioButton
		radio = v
		data = getNextItem(list1)
		radio.Checked = data(0)
	Else If v Is ToggleButton Then
		Private toggle As ToggleButton
		toggle = v
		data = getNextItem(list1)
		toggle.Checked = data(0)
	Else If v Is SeekBar Then
		Private seek As SeekBar
		seek = v
		data = getNextItem(list1)
		seek.Value = data(0)
	Else If v Is TabHost Then
		Private th As TabHost
		th = v
		data = getNextItem(list1)
		For i = 0 To th.TabCount - 1
			th.CurrentTab = i
		Next
		th.CurrentTab = data(0)
		Private r As Reflector
		r.Target = th
		Private tabParentPanel As Panel
		tabParentPanel = r.RunMethod("getTabContentView")
		For i = 0 To tabParentPanel.NumberOfViews - 1
			innerRestoreState(tabParentPanel.GetView(i), list1)
		Next
	Else If v Is ScrollView Then
		Private sv As ScrollView
		sv = v
		data = getNextItem(list1)
		sv.ScrollPosition = data(0)
		Sleep(10)					' DoEvents
		sv.ScrollPosition = data(0)
		innerRestoreState(sv.Panel, list1)
	Else If v Is Panel Then
		Private panel1 As Panel
		panel1 = v
		For i = 0 To panel1.NumberOfViews - 1
			innerRestoreState(panel1.GetView(i), list1)
		Next
	End If
End Sub

Sub getNextItem(list1 As List) As Object()
	listPosition = listPosition + 1
	Return list1.Get(listPosition)
End Sub


